/* selfDHCP
 * Copyright (C) 2002-2003 Enrico "WiseLYNX" Manzini
 *
 * module:		selfdhcp_arpp.h
 * purposes:	definitions and data structures for arp poisoning et similia
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef __SELFDHCP_ARPP_H
#define __SELFDHCP_ARPP_H

/* extern variables passed from the main function */
extern int program_flags;
extern char *prog_name;

#include <stdlib.h>
//#include <libnet.h>
//#include <netinet/if_ether.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "selfdhcp_struct.h"
//#include "selfdhcp_heuristics.h"

/* extern variables passed from the main function */
extern int program_flags;
extern char *prog_name;

/* number of 0 padded bytes in the ARP reply */
#define ARP_PAD						18

/* this structure holds data to be passed to function arpp_doit() */
typedef struct arpp_args
{
  char *device;
#ifndef NEW_LIBNET_INTERFACE
  u_char *packetbuff;
  struct libnet_link_int *net_link;
#else
  libnet_t *lnet_struct;
#endif
  int arpdim;
  int tosleep;
} arpp_args_t;

/* default dimension of the switch ARP table */
#define SWITCH_ARPTABLE_DIM		2048
/* default timeout between ARP flooding (secs) */
#define SWITCH_TIMEOUT			10
#define ARPFLOOD_WAIT			1

/* upper and lower margins for IP range to use in flooding */
#define IP_LO					0xe0000000
#define IP_UP					0xf0000000
//#define IP_LO                                 0xa0000000
//#define IP_UP                                 0xc0000000
#define IP_RANGE				(IP_UP-IP_LO)

/* macro to generate a random IP */
#define GEN_RAND_IP(void)	htonl(IP_LO+(uint32_t)((uint32_t)rand()%IP_RANGE))

/* function arpp_init()
 * This function is used once to initialize all the libnet stuff used in the
 * flooding process.
 */
void arpp_init (arpp_args_t * toinit);

/* function arpp_doit()
 * This is the mail loop of the flooding process. The function is called through
 * pthread_create(), so arguments are passed with a void**; see selfdhcp_arpp.h
 * for details about it.
 */
void arpp_doit (void **void_args);

/* function build_and_inject()
 * This function does the dirty work of building and injecting the ICMP echoes
 * required for the flooding. The argument type must be ICMP_ECHO or
 * ICMP_ECHOREPLY.
 */
void build_and_inject (arpp_args_t * args, uint32_t src_ip, uint32_t dst_ip,
		       u_char * src_mac, /*u_char *dst_mac, */ u_char type);

u_short do_ip_chksm (u_char * ippack, int size);

void rand_mac (u_char * mac2rand);

#endif
